mob/Enemies
	AoE=0
	mouse_opacity=0
	icon='Enemies.dmi'
	AttackTypes=list("Melee")

	Cobra
		MaxHP=25
		MeleePower=10
		AttackAni="Bite"
		icon_state="Cobra"
	Wolf
		MaxHP=50
		MeleePower=10
		AttackAni="Claw"
		icon_state="Wolf"
		Weaknesses=list("Magic")
		Resistances=list("Melee")
	WereWolf
		MaxHP=100
		MeleePower=15
		AttackAni="Claw"
		icon_state="WereWolf"
		Weaknesses=list("Magic")
		Resistances=list("Melee")
	Goblin_Thug
		MaxHP=125
		MeleePower=15
		AttackAni="Slash"
		icon_state="Goblin Thug"
	Goblin_Archer
		MaxHP=100
		Range=5
		RangedPower=10
		AttackAni="Bow"
		icon_state="Goblin Archer"
		Weaknesses=list("Ranged")
		AttackTypes=list("Ranged")
	Goblin_Knight
		MaxHP=150
		MeleePower=20
		AttackAni="Slash"
		icon_state="Goblin Knight"
		Weaknesses=list("Magic")
		Resistances=list("Melee")
		Immunities=list("Ranged")
	Skeleton
		MaxHP=175
		MeleePower=25
		AttackAni="Claws"
		icon_state="Skeleton"
		Weaknesses=list("Melee")
		Immunities=list("Magic")
		CausesEffects=list("Poison")
	Scavanger
		layer=5.5
		MaxHP=200
		density=0
		MeleePower=10
		AttackAni="Bite"
		icon_state="Scavanger"
		Immunities=list("Melee")
	Giant
		icon='Giant.dmi'
		AoE=1
		MaxHP=225
		MeleePower=25
		AttackAni="Hit"
		Resistances=list("Hero")
	Spider
		MaxHP=250
		MeleePower=25
		AttackAni="Web"
		icon_state="Spider"
		Weaknesses=list("Magic")
		CausesEffects=list("Web")
	Dragon
		AoE=1
		layer=5.5
		MaxHP=275
		density=0
		MagicPower=10
		AttackAni="Fire"
		icon_state="Dragon"
		Immunities=list("Melee")
		Resistances=list("Magic")
		AttackTypes=list("Magic")
	Zombie
		MaxHP=300
		MeleePower=35
		AttackAni="Poison"
		icon_state="Zombie"
		Weaknesses=list("Magic")
		CausesEffects=list("Poison")
	Soul_Eater
		MaxHP=325
		MeleePower=30
		AttackAni="Claws"
		icon_state="Soul Eater"
		Resistances=list("Magic")
	Mirror
		MaxHP=350
		MeleePower=35
		AttackAni="Silence"
		icon_state="Mirror"
		Immunities=list("Magic")
		Weaknesses=list("Melee")
		CausesEffects=list("Silence")
	Zombie_Rabbit
		MaxHP=375
		MeleePower=40
		AttackAni="Hit"
		icon_state="Zombie Rabbit"
		Weaknesses=list("Magic")
		Resistances=list("Melee","Ranged")
	Soul_Reaver
		MaxHP=400
		MeleePower=45
		AttackAni="Claws"
		icon_state="Soul Reaver"
		Resistances=list("Magic")
	Vampire
		MaxHP=425
		MeleePower=50
		AttackAni="Bite"
		icon_state="Vampire"
		Weaknesses=list("Magic","Ranged")
		Resistances=list("Melee")
		CausesEffects=list("Vampirism")
	Bomb
		AoE=2
		MaxHP=500
		MeleePower=100
		AttackAni="Explosion"
		icon_state="Bomb"
		Immunities=list("Magic")
	Corpse_Eater
		MaxHP=500
		MeleePower=250
		AttackAni="Smoke"
		icon_state="Corpse Eater"
	Bosses
		Lycan
			AttackAni="Slash"
			icon_state="Lycan"
			Weaknesses=list("Magic")
			Resistances=list("Melee")
		Goblin_King
			AttackAni="Slash"
			icon_state="Goblin King"
		Spider_Queen
			AoE=1
			icon='Spider.dmi'
			Weaknesses=list("Magic")
			CausesEffects=list("Web")
		Dragon
			AoE=2
			layer=5.5
			density=0
			icon='Dragon.dmi'
			Immunities=list("Melee")
			Resistances=list("Magic")
			AttackTypes=list("Magic")
		Mummy
			AoE=1
			icon='Mummy.dmi'
			Weaknesses=list("Magic")
			CausesEffects=list("Poison")
			Resistances=list("Melee","Ranged")
		Dracula
			AoE=1
			AttackAni="Bite"
			icon_state="Dracula"
			Weaknesses=list("Magic","Ranged")
			Resistances=list("Melee")
			CausesEffects=list("Vampirism")

	New()
		src.HP=src.MaxHP
		spawn(rand(1,2))	src.MoveAI()
		return ..()

	proc/MeleeAI()
		for(var/mob/Troops/T in oview(1,src))
			if("Melee" in T.Immunities)	continue
			src.dir=get_dir(src,T)
			flick("[src.icon_state]Attack",src)
			for(var/mob/Player/P in orange(10,src))	P.PlaySoundEffect(pick(PunchSounds),"Punches")
			for(var/mob/Troops/M in oview(src.AoE,T)+T)
				if("Melee" in M.Immunities)	continue
				ShowEffect(M,src.AttackAni,get_dir(src,M))
				src.Damage(M,"Melee")
			return 1

	proc/RangedAI()
		for(var/mob/Troops/T in oview(src.Range,src))
			if("Ranged" in T.Immunities)	continue
			src.dir=get_dir(src,T)
			for(var/mob/Player/P in orange(10,T))	P.PlaySoundEffect(pick('woodrattle_1.ogg','woodrattle_2.ogg','woodrattle_3.ogg','woodrattle_4.ogg'),"Enemy Archers")
			ShowEffect(T,src.AttackAni,get_dir(src,T))
			flick("[src.icon_state]Ranged",src)
			src.Damage(T,"Ranged")
			return 1

	proc/MagicAI()
		for(var/mob/Troops/T in oview(src.Range,src))
			if("Magic" in T.Immunities)	continue
			src.dir=get_dir(src,T)
			for(var/mob/Player/P in orange(10,T))	P.PlaySoundEffect('burnwitch1.ogg',"Fire")
			flick("[src.icon_state]Magic",src)
			for(var/mob/Troops/M in oview(src.AoE,T)+T)
				if("Magic" in M.Immunities)	continue
				ShowEffect(M,src.AttackAni,get_dir(src,M))
				src.Damage(M,"Magic")
			return 1

	proc/MoveAI()
		var/mob/Troops/Gold/GoldLoc
		while(src)
			if(!GoldLoc)
				var/list/GoldLocs=list()
				for(var/mob/Troops/Gold/G in world)	GoldLocs+=G
				GoldLoc=pick(GoldLocs)
			var/HasAttacked
			for(var/v in src.AttackTypes)	HasAttacked=call(src,"[v]AI")()
			if(!HasAttacked	&& !step_to(src,GoldLoc) && !step_towards(src,GoldLoc))	step_rand(src)
			sleep(rand(8,12))