//Low CPU HUD Management
//ID is the "list" of HUD text to create/update
//First, use of WriteHUDText(): Feed NewText as your max length string, ie: 9999
//After that, just use UpdateHUDText() with the same ID and actual text as NewText
//hudx/hudpixx/etc should be easy enough positional variables to understand.
mob/var/list
	ObjectIDs=list()
	LastTextIDs=list()

obj/HUD/LowCPU
	layer=11
	icon='Text.dmi'
	mouse_opacity=0
	var/OrigScreenLoc
	var/OrigX;var/OrigPixX
	var/OrigY;var/OrigPixY
	New(hudx,hudxpix,hudy,hudypix,letter)
		src.icon_state=letter
		src.OrigX=hudx;src.OrigPixX=hudxpix
		src.OrigY=hudy;src.OrigPixY=hudypix
		src.screen_loc="[hudx]:[hudxpix],[hudy]:[hudypix]"
		src.OrigScreenLoc=src.screen_loc

mob/proc/WriteHUDText(var/hudx,var/hudxpix,var/hudy,var/hudypix,var/ID,var/NewText)
	if(!src.client)	return
	var/firstpos=0
	var/PixelSpace=6
	NewText="[NewText]"
	var/list/IdList=list()
	src.LastTextIDs[ID]="/i"
	if(!(ID in src.ObjectIDs))	{src.ObjectIDs+=ID;src.ObjectIDs[ID]=list()}
	for(var/obj/O in src.ObjectIDs["[ID]"])	del O
	while(src)
		firstpos+=1
		var/letter=copytext(NewText,firstpos,firstpos+1)
		if(!letter)	{src.ObjectIDs["[ID]"]=IdList;break}
		var/obj/HUD/LowCPU/O=new(hudx,hudxpix,hudy,hudypix,letter)
		src.client.screen+=O
		IdList+=O
		hudxpix+=PixelSpace
		if(hudxpix>=32)
			hudx+=1;hudxpix-=32

mob/proc/UpdateHUDText(var/ID,var/NewText)
	if(!src.client)	return
	var/firstpos=0
	NewText="[NewText]"
	if(src.LastTextIDs[ID]==NewText)	return
	src.LastTextIDs[ID]=NewText
	if(!(ID in src.ObjectIDs))	{src.ObjectIDs+=ID;src.ObjectIDs[ID]=list()}
	var/list/IdList=src.ObjectIDs["[ID]"]
	src.client.screen-=IdList
	var/SlimOffset=0
	while(src)
		firstpos+=1
		var/letter=copytext(NewText,firstpos,firstpos+1)
		if(!letter)	return
		if(firstpos>IdList.len)	return
		var/obj/HUD/LowCPU/O=IdList[firstpos]
		if(O)
			O.icon_state=letter
			var/LowOffset=LowLetter(letter)*2
			if(SlimOffset || LowOffset)	O.screen_loc="[O.OrigX]:[O.OrigPixX-SlimOffset],[O.OrigY]:[O.OrigPixY-LowOffset]"
			else	O.screen_loc=O.OrigScreenLoc
			if(SlimLetter(letter))	SlimOffset+=4
			src.client.screen+=O

//Additional /procs - necessity varies by Text.dmi layout
proc/LowLetter(var/L)
	if(L=="g"||L=="j"||L=="p"||L=="q"||L=="y"||L==",")	return 1
	else	return 0

proc/SlimLetter(var/L)
	if(L=="i"||L=="l"||L==","||L=="."||L=="'"||L=="!"||L==":")	return 1
	else	return 0