proc
	AutoStart()
		spawn(31)	StartWave()
	List2Text(var/list/L,var/Seperator)
		for(var/v in L)	.+="[v][Seperator]"
		if(length(.))	.=copytext(.,1,length(.)-length(Seperator)+1)

mob/proc
	PlayVoiceWarning(var/SoundFile)
		src.LastVoiceHeard=SoundFile
		src<<sound(SoundFile,channel=1)
	PlayTroopVoice(var/SoundFile)
		src.LastVoiceHeard=SoundFile
		src<<sound(SoundFile,channel=2)

mob/Player/proc
	SoundCooldown()
		while(1)
			for(var/v in src.SoundEffectsHeard)
				if(src.SoundEffectsHeard[v]>1)	src.SoundEffectsHeard[v]-=1
			sleep(2)
	PlaySoundEffect(var/sound/S,var/Category)
		if(!(Category in src.SoundEffectsHeard))	src.SoundEffectsHeard+=Category
		if(src.SoundEffectsHeard[Category]>=10)	return
		src.SoundEffectsHeard[Category]+=1
		src<<sound(S,volume=src.SoundEffectVolume*100)

mob/proc
	ToolTip(var/Desc,var/Name)
		if(!src.ToolTipsOn)	return
		winset(src,"ToolTipWindow.NameLabel","text=\"[Name]\"")
		winset(src,"ToolTipWindow.DescLabel","text=\"[Desc]\"")
		winset(src,"ToolTipWindow","pos=[640-248-150],[720-136-64];is-visible=true")
		src.SetFocus("MainWindow.MainMap")
	CloseToolTip()
		winset(src,"ToolTipWindow","is-visible=false")

mob/proc
	HasEffect(var/Effect2Have)
		if(Effect2Have in src.HasEffects)	return 1
	UpdateScores()
		if(findtext(src.key,"Guest-") || (src in Spectators))	return
		if(!src.LateJoiner)	spawn()
			var/params=list("Name"=src.key,"Wave"=Wave,"Time"=GameTime,"Slain"=EnemiesSlain,"Version"=GameVersion,"HubContact"=1)
			var/GotScores=params2list(world.GetScores(src.key,list2params(params)))
			if(text2num(GotScores["HubContact"]) && (Wave>text2num(GotScores["Wave"]) || GameTime>text2num(GotScores["Time"]) || EnemiesSlain>text2num(GotScores["Slain"])))
				world.SetScores(src.key,list2params(params))
				return 1
	ResetToggleOptions()
		src.see_invisible=1
		winset(src,"MainWindow.GridButton","is-checked=true")
		winset(src,"MainWindow.AutoStartButton","is-checked=[AutoPlay ? "true" : "false"]")
	AddGold(var/Amt=0)
		src.Gold+=Amt
		src.UpdateGold()
	TakeGold(var/Amt=0,var/UsePot=1)
		if(UsePot)
			if(Amt>GoldPot+src.Gold)	return
			if(Amt>GoldPot)	{Amt-=GoldPot;GoldPot=0}
			else	{GoldPot-=Amt;Amt=0}
			for(var/mob/Player/P in world.contents-src)	P.UpdateGold()
		else	if(Amt>src.Gold)	return
		src.Gold-=Amt
		src.UpdateGold()
		return 1
	UpdateGold(/**/)
		src.suffix="[src.Gold] Gold"
		var/GoldTag="[src.Gold+GoldPot]"
		if(src in Spectators)	GoldTag="Spectating"
		src.UpdateHUDText("Gold","Gold: [GoldTag] - Wave: [global.Wave]")

	LevelUp(var/Exp2Give=10)
		src.Exp+=Exp2Give
		if(src.Exp>=100)
			src.Exp-=100;src.Level+=1
			ShowEffect(src,"Level UP")
			if(src.client)
				switch(src.Level)
					if(10)	src.GiveMedal("Heroic","Raise your Hero to Level 10")
					if(25)	src.GiveMedal("War Hero","Raise your Hero to Level 25")
					if(50)	src.GiveMedal("Champion","Raise your Hero to Level 50")
					if(100)	src.GiveMedal("Legendary","Raise your Hero to Level 100")
	Damage(var/mob/Target,var/AttackType)
		var/Damage=src.vars["[AttackType]Power"]
		if(AttackType in Target.Weaknesses)	Damage=Damage*2
		if(AttackType in Target.Resistances)	Damage=round(Damage/2)
		if(Target.HasUpgrade("Block"))	if(rand(1,100)<=25)	Damage=0
		if(AttackType=="Ranged" && Target.HasUpgrade("Deflect"))	if(rand(1,100)<=25)	Damage=0
		if(!Damage)	ShowEffect(Target,"Block",get_dir(src,Target))
		for(var/v in src.CausesEffects)	Target.AddEffect(v)
		Target.HP-=Damage;Target.DeathCheck(src)
	AddEffect(var/Effect2Add)
		if(istype(src,/mob/Troops/Gold))	return
		if(!(Effect2Add in src.HasEffects))
			var/ThisEffectID=rand(1,999999)
			if(!src.HasEffects)	src.HasEffects=list()
			src.HasEffects+=Effect2Add
			src.HasEffects[Effect2Add]=ThisEffectID
			if(Effect2Add=="Poison")
				if(src.HasUpgrade("Immunity"))	return
				src.overlays+=global.PoisonedOL
				ShowEffect(src,"Poison")
				spawn(10)	while(src.HasEffect("Poison") && src.HasEffects["Poison"]==ThisEffectID)
					for(var/mob/Troops/T in oview(1,src))	if(T.AddEffect(Effect2Add))	break
					src.HP-=10;src.DeathCheck(src)
					sleep(10)
			if(Effect2Add=="Web")
				if(src.HasUpgrade("Fire Aura"))	return
				src.overlays+=global.DisabledOL
			if(Effect2Add=="Silence")
				if(src.HasUpgrade("Loud"))	return
				src.overlays+=global.SilencedOL
			if(Effect2Add=="Vampirism")
				src.overlays+=global.VampiredOL
				spawn(10)	if(src.HasEffect("Vampirism") && src.HasEffects["Vampirism"]==ThisEffectID)
					EnemiesRemaining+=1;new/mob/Enemies/Vampire(src.loc)
					src.loc=null;src.HP=0;src.DeathCheck()
			return 1
	DeathCheck(var/mob/Killer)
		if(src.HP>0)	return
		for(var/mob/Player/P in orange(10,src.loc))	P.PlaySoundEffect(pick('swordbasic_01.ogg','swordbasic_02.ogg'),"Death")
		var/obj/Corpse/C=new(src)
		C.icon=src.icon;C.icon_state="[src.icon_state]Dead"
		if(istype(src,/mob/Troops) && !istype(src,/mob/Troops/Gold))	TroopsLost+=1
		if(istype(src,/mob/Enemies))
			Killer.LevelUp()
			EnemiesSlain+=1
			EnemiesRemaining-=1
			switch(GoldMode)
				if("Split")	for(var/mob/Player/P in Players)	P.AddGold(max(1,round(10/Players.len,1)))
				if("Shared")	{global.GoldPot+=10;for(var/mob/Player/P in Players)	P.UpdateGold()}
				if("Earned")
					if(istype(Killer,/mob/Player))
						if(Killer in Players)	Killer.AddGold(10)
						else	global.GoldPot+=10
					else	if(istype(Killer,/mob/Troops))	Killer.Owner.AddGold(10)
					else	global.GoldPot+=10
			if(EnemiesRemaining<=0 && WaveInProgress)
				WaveInProgress=0
				for(var/mob/Player/P in world)
					P.DayTime()
					P.UpdateScores()
					if(Wave==5 && !global.TroopsPlaced)	P.GiveMedal("Sole Survivor","Complete Wave 5 Before Placing Troops")
				if(AutoPlay)	AutoStart()
		if(istype(src,/mob/Troops/Gold))
			var/GoldRemaining=0
			for(var/mob/Troops/Gold/G in world)	GoldRemaining+=max(0,G.HP)
			if(GoldRemaining<=0)
				world<<"<b>The end is nigh...  Survived [global.Wave] Waves for [global.GameTime] Seconds of Combat Time, Slaying [global.EnemiesSlain] Enemies."
				ClearWorld()
		src.loc=null
	HasUpgrade(var/ThisUpgrade)
		if(ThisUpgrade in src.Upgrades)	return 1

world/New()
	spawn()	PopulateEffects()
	return ..()
var/list/EffectObjs=list()
proc/PopulateEffects()
	for(var/i=1;i<=500,i++)	EffectObjs+=new/obj/Effect
obj/Effect
	layer=6
	mouse_opacity=0
	icon='Effects.dmi'
proc/ShowEffect(var/atom/Loc,var/Effect,var/Dir=SOUTH)
	var/obj/O=EffectObjs[1]
	EffectObjs-=O;EffectObjs+=O
	O.dir=Dir
	O.loc=locate(Loc.x,Loc.y,Loc.z)
	O.pixel_x=rand(-8,8);O.pixel_y=rand(-8,8)
	flick("[Effect]",O)
	spawn(10)	O.loc=null