mob/Troops
	density=0
	var/Category
	var/CanRevive=1
	var/list/Images
	var/list/MouseOverers=list()
	mouse_opacity=2
	icon='Troops.dmi'
	New()
		src.HP=src.MaxHP
		spawn()	src.BasicAI()
		return ..()
	Del()
		for(var/mob/Player/P in src.MouseOverers)
			if(P.client)
				P.client.images-=src.Images
				P.CloseToolTip()
		return ..()
	Click(location,control,params)
		if(findtext(params,"right"))	{usr.EscapeKey();return}
		if(usr.client.mouse_pointer_icon && !usr.Placing && src.Owner==usr)
			var/SellPrice=round(src.HP/src.MaxHP*src.Cost)
			TroopsSold+=1;usr.AddGold(SellPrice)
			src.MouseExited();del src
		else	src.loc.Click(location,control,params)
	MouseEntered()
		if(usr.ToolTipsOn && !istype(src,/mob/Troops/Gold))
			src.MouseOverers+=usr
			var/Desc="HP: [src.HP] / [src.MaxHP]\n"
			if(src.Weaknesses)	Desc+="Weaknesses: [List2Text(src.Weaknesses,", ")]\n"
			if(src.Resistances)	Desc+="Resistances: [List2Text(src.Resistances,", ")]\n"
			if(src.AttackTypes)	Desc+="Abilities: [List2Text(src.AttackTypes,", ")]"
			if(src.Upgrades)	Desc+=", [List2Text(src.Upgrades,", ")]\n"
			usr.ToolTip(Desc,"[src.Owner]'s Lvl.[src.Level] [src.name]")
			usr.client.images+=src.Images
	MouseExited()
		usr.client.images-=src.Images
		src.MouseOverers-=usr
		usr.CloseToolTip()
	proc/ResetImages()
		src.Images=list()
		var/RangeColor="Red"
		var/list/VisibleRange
		if(src.HasUpgrade("Arc") || src.HasUpgrade("Insight") || src.Category=="Light Magic")	VisibleRange=orange(src.Range,src)
		else	VisibleRange=oview(src.Range,src)
		if(src.name=="Paladin")
			VisibleRange=oview(1,src)
			for(var/turf/T in orange(src.Range,src))	if(get_dist(src,T)>=2)	src.Images+=image('Other.dmi',T,"RangeGreen",OBJ_LAYER,SOUTH)
		if(src.Category=="Light Magic")
			for(var/turf/T in oview(5,src))	if(get_dist(src,T)>src.Range)	src.Images+=image('Other.dmi',T,"Range[RangeColor]",OBJ_LAYER,SOUTH)
			RangeColor="Green"
		for(var/turf/T in VisibleRange)	src.Images+=image('Other.dmi',T,"Range[RangeColor]",OBJ_LAYER,SOUTH)
	proc
		MeleeAI()
			if(src.HasEffect("Web"))	return
			for(var/mob/Enemies/E in oview(1,src))
				if("Melee" in E.Immunities)	continue
				src.dir=get_dir(src,E)
				for(var/mob/Player/P in orange(10,src))	P.PlaySoundEffect(pick(SwordSounds),"Swords")
				ShowEffect(E,"Slash",get_dir(src,E))
				flick("[src.icon_state]Attack",src)
				src.Damage(E,"Melee")
				return 1

		RangedAI()
			var/list/TargetList
			var/mob/Enemies/Target
			if(src.HasEffect("Web"))	return
			if(src.HasUpgrade("Arc"))	TargetList=orange(src.Range,src)
			else	TargetList=oview(src.Range,src)
			for(var/mob/Enemies/T in TargetList)
				//Priority Target Ranged Attackers
				if("Ranged" in T.Immunities)	continue
				if("Ranged" in T.AttackTypes)	{Target=T;break}
				else	if(!Target)	Target=T
			if(Target)
				for(var/mob/Player/P in orange(10,src))	P.PlaySoundEffect(pick('arrowshoot1 22k.ogg','arrowswish1 22k.ogg','arrowswish2 22k.ogg'),"Archers")
				src.dir=get_dir(src,Target)
				ShowEffect(Target,"Bow",get_dir(src,Target))
				flick("[src.icon_state]Ranged",src)
				src.Damage(Target,"Ranged")
				return 1

		HealingAI()
			var/TargetsCured=0
			if(src.HasEffect("Silence") || src.HasEffect("Web"))	return
			if(src.HasUpgrade("Break"))	for(var/mob/Enemies/E in oview(5,src))
				if("Magic" in E.Immunities)	continue
				src.dir=get_dir(src,E)
				ShowEffect(E,"Break",get_dir(src,E))
				flick("[src.icon_state]Heal",src)
				src.Damage(E,"Magic")
			if(istype(src,/mob/Troops/Saint) && src.CanRevive)
				for(var/obj/Corpse/C in oview(src.Range,src))
					if(istype(C.Troop,/mob/Troops))
						for(var/mob/Troops/T in C.loc)	goto NEXT
						if(istype(C.Troop,/mob/Troops/Gold))	goto NEXT
						src.CanRevive=0;spawn(10)	src.CanRevive=1
						ShowEffect(C.loc,"Level UP")
						C.Troop.HP=C.Troop.MaxHP
						C.Troop.loc=C.loc
						TroopsRevived+=1
						TroopsLost-=1
						src.LevelUp()
						del C
						break
						NEXT
			for(var/mob/Troops/T in range(src.Range,src))
				if(istype(T,/mob/Troops/Gold))	continue
				if(!TargetsCured || src.HasUpgrade("Radial Cure"))
					if(T.HasEffect("Poison") && src.HasUpgrade("Cure"))
						src.LevelUp(1)
						TargetsCured+=1
						T.overlays-=PoisonedOL
						T.HasEffects-="Poison"
						ShowEffect(T,"Cure",get_dir(src,T))
				if(T.HasEffect("Silence") && src.HasUpgrade("Needle"))
					src.LevelUp(1)
					T.overlays-=SilencedOL
					T.HasEffects-="Silence"
					ShowEffect(T,"Needle",get_dir(src,T))
				if(T.HasEffect("Vampirism") && src.HasUpgrade("Purify"))
					src.LevelUp(1)
					T.overlays-=VampiredOL
					T.HasEffects-="Vampirism"
					ShowEffect(T,"Purify",get_dir(src,T))
				if(T.HP<T.MaxHP)
					src.LevelUp(1)
					src.dir=get_dir(src,T)
					T.HP+=src.HealingPower
					ShowEffect(T,"Heal",get_dir(src,T))
					flick("[src.icon_state]Heal",src)
					if(!src.HasUpgrade("Radial Heal"))	return 1

		MagicAI()
			var/list/TargetList
			if(src.HasEffect("Silence") || src.HasEffect("Web"))	return
			if(src.HasUpgrade("Insight"))	TargetList=orange(src.Range,src)
			else	TargetList=oview(src.Range,src)
			for(var/mob/Troops/T in TargetList)
				if(istype(T,/mob/Troops/Gold))	continue
				if(T.HasEffect("Web") && src.HasUpgrade("Free Burn"))
					src.LevelUp(1)
					T.overlays-=DisabledOL
					T.HasEffects-="Web"
					ShowEffect(T,"Free Burn",get_dir(src,T))
			for(var/mob/Enemies/E in TargetList)
				if("Magic" in E.Immunities)	continue
				src.dir=get_dir(src,E)
				ShowEffect(E,"Fire",get_dir(src,E))
				flick("[src.icon_state]Magic",src)
				for(var/mob/Player/P in orange(10,E))	P.PlaySoundEffect('burnwitch1.ogg',"Fire")
				if(src.HasUpgrade("Inferno"))	for(var/mob/Enemies/E2 in oview(src.AoE,E))
					ShowEffect(E2,"Fire",get_dir(src,E2))
					src.Damage(E2,"Magic")
				src.Damage(E,"Magic")
				return 1

		BasicAI()
			while(src)
				for(var/v in src.AttackTypes)	call(src,"[v]AI")()
				sleep(rand(16,24))

	Gold
		Range=0
		MaxHP=250
		icon='Other.dmi';icon_state="Gold3"

	Squire
		MaxHP=100
		MeleePower=25
		Category="Melee"
		icon_state="Squire"
		AttackTypes=list("Melee")
	Knight
		MaxHP=250
		MeleePower=25
		Category="Melee"
		icon_state="Knight"
		Resistances=list("Melee")
		AttackTypes=list("Melee")
	Dragoon
		MaxHP=500
		MeleePower=25
		Category="Melee"
		icon_state="Dragoon"
		AttackTypes=list("Melee")
		Resistances=list("Melee","Magic")

	Archer
		MaxHP=50
		Range=5
		RangedPower=10
		Category="Ranged"
		icon_state="Archer"
		AttackTypes=list("Ranged")
	Ranger
		MaxHP=100
		Range=5
		MeleePower=25
		RangedPower=10
		Category="Ranged"
		icon_state="Ranger"
		Resistances=list("Ranged")
		AttackTypes=list("Ranged","Melee")

	Cleric
		Range=3
		MaxHP=25
		MagicPower=10
		HealingPower=10
		icon_state="Cleric"
		Category="Light Magic"
		AttackTypes=list("Healing")
	Paladin
		Range=3
		MaxHP=125
		MeleePower=25
		MagicPower=10
		HealingPower=10
		icon_state="Paladin"
		Category="Melee"
		AttackTypes=list("Melee","Healing")
	Saint
		Range=4
		MaxHP=25
		MagicPower=10
		HealingPower=10
		icon_state="Saint"
		Category="Light Magic"
		AttackTypes=list("Healing")

	Wizard
		AoE=1
		Range=5
		MaxHP=25
		MagicPower=20
		icon_state="Wizard"
		Category="Dark Magic"
		AttackTypes=list("Magic")
	Dark_Knight
		AoE=1
		Range=5
		MaxHP=125
		MagicPower=20
		icon_state="Dark Knight"
		Category="Dark Magic"
		Resistances=list("Magic")
		AttackTypes=list("Melee","Magic")
	War_Lord
		AoE=2
		Range=5
		MaxHP=500
		MagicPower=20
		icon_state="War Lord"
		Category="Dark Magic"
		AttackTypes=list("Magic")
		Resistances=list("Melee","Magic")